//
// CheesyPlayer
// by Eric Shepherd
//
// Eric Shepherd
//
// Copyright 1998, Be Incorporated.
//
// Module:	MediaApp.cpp
//			Application class code.
//

#include <Message.h>
#include "MediaApp.h"
#include "MediaPlayer.h"
#include <Beep.h>
#include <Entry.h>

//
// MediaApp::MediaApp
//
// Get set up, baby.
//
MediaApp::MediaApp(char *filename) :
			BApplication("application/x-vnd.Be-SimplePlayer") {
	entry_ref ref;
	
	get_ref_for_path(filename, &ref);
	player = OpenRef(&ref);
	SetPulseRate(50000);
}

//
// MediaApp::Pulse
//
// Called periodically; if the movie is done playing,
// ask ourselves to quit.
//
void MediaApp::Pulse(void) {
	if (player) {
		if (!player->Playing()) {
			SetPulseRate(0);		// No more pulses, please
			delete player;
			player = NULL;
			PostMessage(B_QUIT_REQUESTED);
		}
	}
	else {
		PostMessage(B_QUIT_REQUESTED);
	}
}

//
// MediaApp::OpenRef
//
// Open a new media player window, given an entry_ref.  Returns
// true if okay.
//
MediaPlayer *MediaApp::OpenRef(entry_ref *ref) {
	MediaPlayer *player = new MediaPlayer(ref);
	if (player->InitCheck() != B_OK) {
		printf("Can't set up the player\n");
		delete player;
		return NULL;
	}
	return player;
}
